<template>
  <div>
    <Navbar style="position: fixed;"/>
    <section class="container">
      <ParticipantList :participant-list="selectedParticipants" :callback-click-item="unSelect" title="Selecionados"/>
      <ParticipantList :participant-list="notSelectedParticipants" :callback-click-item="onSelect" title="Não selecionados"/>
      <Button :text="'Salvar'" class="button-select-page"/>
    </section>
  </div>
</template>

<script>
import ParticipantList from "~/components/ParticipantList.vue";
import Navbar from "~/components/Navbar.vue";
import Button from "~/components/Button.vue";
import gql from "graphql-tag";

function selectedMock() {
  return [
    {
      name: "Victor Hugo M. Pinto",
      id: 1,
      isSelected: true
    },
    {
      name: "Ygor Tavela Alves",
      id: 12,
      isSelected: true
    },
    {
      name: "Caio Andrade Deus",
      id: 123,
      isSelected: true
    },
    {
      name: "Napoli Tiago Martins",
      id: 3,
      isSelected: true
    }
  ];
}

function notSelectedMock() {
  return [
    {
      name: "João",
      isSelected: false,
      id: 5
    },
    {
      name: "Wander",
      isSelected: false,
      id: 65
    },
    {
      name: "Karina",
      isSelected: false,
      id: 92
    },
    {
      name: "Listinha",
      isSelected: false,
      id: 213
    }
  ];
}

export default {
  components: {
    ParticipantList,
    Navbar,
    Button
  },
  data: function() {
    return {
      selectedParticipants: [],
      notSelectedParticipants: [],
      participant_list: []
    };
  },
  apollo: {
    registeredList: gql`
      query {
        registeredList {
          id
        }
      }
    `
  },
  created() {
    this.selectedParticipants = selectedMock();
    this.notSelectedParticipants = notSelectedMock();
  },
  methods: {
    onSelect(event, participantToSelect) {
      this.notSelectedParticipants = this.notSelectedParticipants.filter(
        participant => {
          return participant !== participantToSelect;
        }
      );
      this.selectedParticipants.push(participantToSelect);
      participantToSelect.isSelected = !participantToSelect.isSelected;
    },
    unSelect(event, participantToUnselect) {
      this.selectedParticipants = this.selectedParticipants.filter(
        participant => {
          return participant !== participantToUnselect;
        }
      );
      this.notSelectedParticipants.push(participantToUnselect);
      participantToUnselect.isSelected = !participantToUnselect.isSelected;
    }
  }
};
</script>

<style lang="scss" scoped>
.container {
  padding-top: 20vh;
  min-height: 100vh;
  min-width: 100vw;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  text-align: center;
}

.submit-btn {
  background-color: red;
  width: 90vw;
  height: 3em;
  max-width: 40em;
  display: flex;
  justify-content: center;
  align-items: center;
}

.button-select-page {
  margin: 2vh 0;
}
</style>
